package cat.xtec.ioc.domain.repository.impl;

import cat.xtec.ioc.domain.Show;
import cat.xtec.ioc.domain.repository.ShowRepository;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import org.springframework.stereotype.Repository;


@Repository
public class InMemoryShowRepository implements ShowRepository {

    private final Map<String, Show> shows = new HashMap<String, Show>();

    public InMemoryShowRepository() {
        Show u2 = new Show("1", "U2 360 Tour", 5);
        u2.setLocation("Palau Sant Jordi");
             
        Show burana = new Show("2", "Carmina Burana", 3);
        burana.setLocation("Palau de la musica");        
        shows.put("1", u2);
        shows.put("2", burana);
    }

    public Collection<Show> getAllShows() {
        return shows.values();
    }
    
    public Show makeReservation(String showId) {
        Show reservation = this.shows.get(showId);
        reservation.makeTicketReservation();
        return reservation;
    }
    
    public Show cancelReservation(String showId) {
        Show reservation = this.shows.get(showId);
        reservation.makeTicketCancellation();
        return reservation;
    }
}
